#include "clisp.h"

extern gcv_object_t module__pari__object_tab[];
#undef T
#include <pari/pari.h>
char* get_entry_doc (char* s);
char* get_entry_doc (char* s) { entree *e = is_entry(s); return e==NULL?NULL:e->help; }
#include "cpari.h"
GEN subres0 (GEN x, GEN y);
GEN subres0 (GEN x, GEN y) { return subres(x,y); }

void get_integer_data (GEN x, ulong len, ulong *data);
void get_integer_data (GEN x, ulong len, ulong *data)
{ ulong i; for (i=0; i < len; i++) data[len-i-1] = *int_W(x,i); }
void set_integer_data (GEN x, ulong len, ulong *data);
void set_integer_data (GEN x, ulong len, ulong *data) {
  /* 1st data element is the header, skip it */
  ulong i; len--; data++;
  for (i=0; i < len; i++) *int_W(x,i) = data[len-i-1];
}

subr_t module__pari__subr_tab[1];
uintC module__pari__subr_tab_size = 0;
subr_initdata_t module__pari__subr_tab_initdata[1];

gcv_object_t module__pari__object_tab[1];
object_initdata_t module__pari__object_tab_initdata[1];
uintC module__pari__object_tab_size = 0;

const char* MODULE__PARI__CONSTANT_MAP_C_STRING (int number, int *definedp);
const char* MODULE__PARI__CONSTANT_MAP_C_STRING (int number, int *definedp) {
  *definedp=1;
  switch (number) {
#  if defined(PARIVERSION)
    case 0: return PARIVERSION;
#  endif
#  if defined(PARIINFO)
    case 1: return PARIINFO;
#  endif
    default: *definedp=0; return 0;
  }
}
long MODULE__PARI__CONSTANT_MAP_LONG (int number, int *definedp);
long MODULE__PARI__CONSTANT_MAP_LONG (int number, int *definedp) {
  *definedp=1;
  switch (number) {
#  if defined(MAXVARN)
    case 0: return MAXVARN;
#  endif
#  if defined(VERYBIGINT)
    case 1: return VERYBIGINT;
#  endif
#  if defined(BIGINT)
    case 2: return BIGINT;
#  endif
#  if defined(PARI_VERSION_CODE)
    case 3: return PARI_VERSION_CODE;
#  endif
#  if defined(PARI_VERSION_SHIFT)
    case 4: return PARI_VERSION_SHIFT;
#  endif
    default: *definedp=0; return 0;
  }
}
unsigned long MODULE__PARI__CONSTANT_MAP_ULONG (int number, int *definedp);
unsigned long MODULE__PARI__CONSTANT_MAP_ULONG (int number, int *definedp) {
  *definedp=1;
  switch (number) {
#  if defined(SIGNBITS)
    case 0: return SIGNBITS;
#  endif
#  if defined(SIGNSHIFT)
    case 1: return SIGNSHIFT;
#  endif
#  if defined(TYPBITS)
    case 2: return TYPBITS;
#  endif
#  if defined(TYPSHIFT)
    case 3: return TYPSHIFT;
#  endif
#  if defined(LGBITS)
    case 4: return LGBITS;
#  endif
#  if defined(EXPOBITS)
    case 5: return EXPOBITS;
#  endif
#  if defined(HIGHEXPOBIT)
    case 6: return HIGHEXPOBIT;
#  endif
#  if defined(VALPBITS)
    case 7: return VALPBITS;
#  endif
#  if defined(HIGHVALPBIT)
    case 8: return HIGHVALPBIT;
#  endif
#  if defined(PRECPBITS)
    case 9: return PRECPBITS;
#  endif
#  if defined(PRECPSHIFT)
    case 10: return PRECPSHIFT;
#  endif
#  if defined(VARNBITS)
    case 11: return VARNBITS;
#  endif
#  if defined(VARNSHIFT)
    case 12: return VARNSHIFT;
#  endif
#  if defined(CLONEBIT)
    case 13: return CLONEBIT;
#  endif
    default: *definedp=0; return 0;
  }
}

void module__pari__init_function_1 (module_t* module);

void module__pari__init_function_2 (module_t* module);

void module__pari__fini_function (module_t* module);


void module__pari__init_function_1 (module_t* module)
{
  register_foreign_inttype("ssize_t",sizeof(ssize_t),(ssize_t)-1<=(ssize_t)0);
  register_foreign_inttype("size_t",sizeof(size_t),(size_t)-1<=(size_t)0);
}

void module__pari__init_function_2 (module_t* module)
{
init_for_clisp(4000000,500000);

  register_foreign_variable((void*)&precdl,"precdl",0,sizeof(precdl));
  register_foreign_variable((void*)&avma,"avma",0,sizeof(avma));
  register_foreign_variable((void*)&top,"top",0,sizeof(top));
  register_foreign_variable((void*)&bot,"bot",0,sizeof(bot));
  register_foreign_variable((void*)&gpi,"gpi",1,sizeof(gpi));
  register_foreign_variable((void*)&geuler,"geuler",1,sizeof(geuler));
  register_foreign_variable((void*)&bernzone,"bernzone",1,sizeof(bernzone));
  register_foreign_variable((void*)&gen_1,"gen_1",1,sizeof(gen_1));
  register_foreign_variable((void*)&gen_2,"gen_2",1,sizeof(gen_2));
  register_foreign_variable((void*)&ghalf,"ghalf",1,sizeof(ghalf));
  register_foreign_variable((void*)&gi,"gi",1,sizeof(gi));
  register_foreign_variable((void*)&gen_0,"gen_0",1,sizeof(gen_0));
  register_foreign_variable((void*)&gen_m1,"gen_m1",1,sizeof(gen_m1));
  register_foreign_variable((void*)&gnil,"gnil",1,sizeof(gnil));
  register_foreign_variable((void*)&pol_1,"pol_1",1,sizeof(pol_1));
  register_foreign_variable((void*)&pol_x,"pol_x",1,sizeof(pol_x));
  register_foreign_variable((void*)&primetab,"primetab",1,sizeof(primetab));
  register_foreign_variable((void*)&ordvar,"ordvar",1,sizeof(ordvar));
  register_foreign_variable((void*)&polvar,"polvar",1,sizeof(polvar));
  register_foreign_variable((void*)&diffptr,"diffptr",1,sizeof(diffptr));
  register_foreign_variable((void*)&varentries,"varentries",1,sizeof(varentries));
  register_foreign_variable((void*)&new_galois_format,"new_galois_format",0,sizeof(new_galois_format));
  register_foreign_variable((void*)&factor_add_primes,"factor_add_primes",0,sizeof(factor_add_primes));
  register_foreign_variable((void*)&DEBUGFILES,"DEBUGFILES",0,sizeof(DEBUGFILES));
  register_foreign_variable((void*)&DEBUGLEVEL,"DEBUGLEVEL",0,sizeof(DEBUGLEVEL));
  register_foreign_variable((void*)&DEBUGMEM,"DEBUGMEM",0,sizeof(DEBUGMEM));
  register_foreign_function((void*)&is_entry,"is_entry",1024);
  register_foreign_function((void*)&get_entry_doc,"get_entry_doc",1024);
  register_foreign_function((void*)&allocatemoremem,"allocatemoremem",1024);
  register_foreign_function((void*)&init_for_clisp,"init_for_clisp",1024);
  register_foreign_function((void*)&pari_close,"pari_close",1024);
  register_foreign_function((void*)&gtrans,"gtrans",1024);
  register_foreign_function((void*)&gscalmat,"gscalmat",1024);
  register_foreign_function((void*)&inverseimage,"inverseimage",1024);
  register_foreign_function((void*)&ker,"ker",1024);
  register_foreign_function((void*)&keri,"keri",1024);
  register_foreign_function((void*)&image,"image",1024);
  register_foreign_function((void*)&imagecompl,"imagecompl",1024);
  register_foreign_function((void*)&suppl,"suppl",1024);
  register_foreign_function((void*)&eigen,"eigen",1024);
  register_foreign_function((void*)&hess,"hess",1024);
  register_foreign_function((void*)&carhess,"carhess",1024);
  register_foreign_function((void*)&gauss,"gauss",1024);
  register_foreign_function((void*)&det,"det",1024);
  register_foreign_function((void*)&caradj,"caradj",1024);
  register_foreign_function((void*)&adj,"adj",1024);
  register_foreign_function((void*)&caradj0,"caradj0",1024);
  register_foreign_function((void*)&gtrace,"gtrace",1024);
  register_foreign_function((void*)&gnorm,"gnorm",1024);
  register_foreign_function((void*)&gnorml2,"gnorml2",1024);
  register_foreign_function((void*)&gconj,"gconj",1024);
  register_foreign_function((void*)&conjvec,"conjvec",1024);
  register_foreign_function((void*)&matid,"matid",1024);
  register_foreign_function((void*)&concat,"concat",1024);
  register_foreign_function((void*)&extract,"extract",1024);
  register_foreign_function((void*)&matextract,"matextract",1024);
  register_foreign_function((void*)&gtomat,"gtomat",1024);
  register_foreign_function((void*)&sqred,"sqred",1024);
  register_foreign_function((void*)&signat,"signat",1024);
  register_foreign_function((void*)&jacobi,"jacobi",1024);
  register_foreign_function((void*)&matrixqz,"matrixqz",1024);
  register_foreign_function((void*)&matrixqz2,"matrixqz2",1024);
  register_foreign_function((void*)&matrixqz3,"matrixqz3",1024);
  register_foreign_function((void*)&indexrank,"indexrank",1024);
  register_foreign_function((void*)&kerint,"kerint",1024);
  register_foreign_function((void*)&kerint1,"kerint1",1024);
  register_foreign_function((void*)&intersect,"intersect",1024);
  register_foreign_function((void*)&deplin,"deplin",1024);
  register_foreign_function((void*)&detint,"detint",1024);
  register_foreign_function((void*)&rank,"rank",1024);
  register_foreign_function((void*)&perf,"perf",1024);
  register_foreign_function((void*)&gp_read_str,"gp_read_str",1024);
  register_foreign_function((void*)&racine,"racine",1024);
  register_foreign_function((void*)&mpfact,"mpfact",1024);
  register_foreign_function((void*)&mpfactr,"mpfactr",1024);
  register_foreign_function((void*)&gcf,"gcf",1024);
  register_foreign_function((void*)&gcf2,"gcf2",1024);
  register_foreign_function((void*)&pnqn,"pnqn",1024);
  register_foreign_function((void*)&gboundcf,"gboundcf",1024);
  register_foreign_function((void*)&bestappr,"bestappr",1024);
  register_foreign_function((void*)&addprimes,"addprimes",1024);
  register_foreign_function((void*)&chinese,"chinese",1024);
  register_foreign_function((void*)&fibo,"fibo",1024);
  register_foreign_function((void*)&nextprime,"nextprime",1024);
  register_foreign_function((void*)&prime,"prime",1024);
  register_foreign_function((void*)&primes,"primes",1024);
  register_foreign_function((void*)&phi,"phi",1024);
  register_foreign_function((void*)&smallfact,"smallfact",1024);
  register_foreign_function((void*)&boundfact,"boundfact",1024);
  register_foreign_function((void*)&sumdiv,"sumdiv",1024);
  register_foreign_function((void*)&sumdivk,"sumdivk",1024);
  register_foreign_function((void*)&numbdiv,"numbdiv",1024);
  register_foreign_function((void*)&binaire,"binaire",1024);
  register_foreign_function((void*)&order,"order",1024);
  register_foreign_function((void*)&gener,"gener",1024);
  register_foreign_function((void*)&znstar,"znstar",1024);
  register_foreign_function((void*)&divisors,"divisors",1024);
  register_foreign_function((void*)&classno,"classno",1024);
  register_foreign_function((void*)&fundunit,"fundunit",1024);
  register_foreign_function((void*)&regula,"regula",1024);
  register_foreign_function((void*)&compimag,"compimag",1024);
  register_foreign_function((void*)&qfi,"qfi",1024);
  register_foreign_function((void*)&qfr,"qfr",1024);
  register_foreign_function((void*)&redreal,"redreal",1024);
  register_foreign_function((void*)&sqcompreal,"sqcompreal",1024);
  register_foreign_function((void*)&sqcompimag,"sqcompimag",1024);
  register_foreign_function((void*)&rhoreal,"rhoreal",1024);
  register_foreign_function((void*)&rhorealnod,"rhorealnod",1024);
  register_foreign_function((void*)&redrealnod,"redrealnod",1024);
  register_foreign_function((void*)&redimag,"redimag",1024);
  register_foreign_function((void*)&primeform,"primeform",1024);
  register_foreign_function((void*)&nucomp,"nucomp",1024);
  register_foreign_function((void*)&nudupl,"nudupl",1024);
  register_foreign_function((void*)&nupow,"nupow",1024);
  register_foreign_function((void*)&comprealraw,"comprealraw",1024);
  register_foreign_function((void*)&powrealraw,"powrealraw",1024);
  register_foreign_function((void*)&gissquare,"gissquare",1024);
  register_foreign_function((void*)&gisprime,"gisprime",1024);
  register_foreign_function((void*)&gispseudoprime,"gispseudoprime",1024);
  register_foreign_function((void*)&gissquarefree,"gissquarefree",1024);
  register_foreign_function((void*)&gisfundamental,"gisfundamental",1024);
  register_foreign_function((void*)&kronecker,"kronecker",1024);
  register_foreign_function((void*)&mu,"mu",1024);
  register_foreign_function((void*)&omega,"omega",1024);
  register_foreign_function((void*)&bigomega,"bigomega",1024);
  register_foreign_function((void*)&hil,"hil",1024);
  register_foreign_function((void*)&maxprime,"maxprime",1024);
  register_foreign_function((void*)&base,"base",1024);
  register_foreign_function((void*)&smallbase,"smallbase",1024);
  register_foreign_function((void*)&discf,"discf",1024);
  register_foreign_function((void*)&smalldiscf,"smalldiscf",1024);
  register_foreign_function((void*)&hnf,"hnf",1024);
  register_foreign_function((void*)&hnfmod,"hnfmod",1024);
  register_foreign_function((void*)&smith,"smith",1024);
  register_foreign_function((void*)&smith2,"smith2",1024);
  register_foreign_function((void*)&factoredbase,"factoredbase",1024);
  register_foreign_function((void*)&factoreddiscf,"factoreddiscf",1024);
  register_foreign_function((void*)&galois,"galois",1024);
  register_foreign_function((void*)&initalg,"initalg",1024);
  register_foreign_function((void*)&initalgred,"initalgred",1024);
  register_foreign_function((void*)&tschirnhaus,"tschirnhaus",1024);
  register_foreign_function((void*)&galoisapply,"galoisapply",1024);
  register_foreign_function((void*)&galoisconj,"galoisconj",1024);
  register_foreign_function((void*)&galoisconj0,"galoisconj0",1024);
  register_foreign_function((void*)&galoisconj2,"galoisconj2",1024);
  register_foreign_function((void*)&galoisconj4,"galoisconj4",1024);
  register_foreign_function((void*)&initalgred2,"initalgred2",1024);
  register_foreign_function((void*)&primedec,"primedec",1024);
  register_foreign_function((void*)&idealmul,"idealmul",1024);
  register_foreign_function((void*)&idealmulred,"idealmulred",1024);
  register_foreign_function((void*)&ideal_two_elt,"ideal_two_elt",1024);
  register_foreign_function((void*)&ideallllred,"ideallllred",1024);
  register_foreign_function((void*)&element_mul,"element_mul",1024);
  register_foreign_function((void*)&element_pow,"element_pow",1024);
  register_foreign_function((void*)&rootsof1,"rootsof1",1024);
  register_foreign_function((void*)&idealinv,"idealinv",1024);
  register_foreign_function((void*)&idealpow,"idealpow",1024);
  register_foreign_function((void*)&idealpowred,"idealpowred",1024);
  register_foreign_function((void*)&idealfactor,"idealfactor",1024);
  register_foreign_function((void*)&idealhermite,"idealhermite",1024);
  register_foreign_function((void*)&idealhnf0,"idealhnf0",1024);
  register_foreign_function((void*)&idealadd,"idealadd",1024);
  register_foreign_function((void*)&idealaddtoone,"idealaddtoone",1024);
  register_foreign_function((void*)&idealaddmultoone,"idealaddmultoone",1024);
  register_foreign_function((void*)&idealdiv,"idealdiv",1024);
  register_foreign_function((void*)&idealintersect,"idealintersect",1024);
  register_foreign_function((void*)&principalideal,"principalideal",1024);
  register_foreign_function((void*)&principalidele,"principalidele",1024);
  register_foreign_function((void*)&idealdivexact,"idealdivexact",1024);
  register_foreign_function((void*)&idealnorm,"idealnorm",1024);
  register_foreign_function((void*)&idealappr,"idealappr",1024);
  register_foreign_function((void*)&idealapprfact,"idealapprfact",1024);
  register_foreign_function((void*)&idealcoprime,"idealcoprime",1024);
  register_foreign_function((void*)&ideal_two_elt2,"ideal_two_elt2",1024);
  register_foreign_function((void*)&basistoalg,"basistoalg",1024);
  register_foreign_function((void*)&algtobasis,"algtobasis",1024);
  register_foreign_function((void*)&nfhermite,"nfhermite",1024);
  register_foreign_function((void*)&nfhermitemod,"nfhermitemod",1024);
  register_foreign_function((void*)&nfsmith,"nfsmith",1024);
  register_foreign_function((void*)&nfdiveuc,"nfdiveuc",1024);
  register_foreign_function((void*)&nfdivrem,"nfdivrem",1024);
  register_foreign_function((void*)&nfmod,"nfmod",1024);
  register_foreign_function((void*)&element_div,"element_div",1024);
  register_foreign_function((void*)&nfdetint,"nfdetint",1024);
  register_foreign_function((void*)&element_reduce,"element_reduce",1024);
  register_foreign_function((void*)&idealval,"idealval",1024);
  register_foreign_function((void*)&isideal,"isideal",1024);
  register_foreign_function((void*)&element_val,"element_val",1024);
  register_foreign_function((void*)&rnfisfree,"rnfisfree",1024);
  register_foreign_function((void*)&rnfpseudobasis,"rnfpseudobasis",1024);
  register_foreign_function((void*)&rnfdiscf,"rnfdiscf",1024);
  register_foreign_function((void*)&rnfsteinitz,"rnfsteinitz",1024);
  register_foreign_function((void*)&rnfbasis,"rnfbasis",1024);
  register_foreign_function((void*)&rnfhnfbasis,"rnfhnfbasis",1024);
  register_foreign_function((void*)&compositum,"compositum",1024);
  register_foreign_function((void*)&initzeta,"initzeta",1024);
  register_foreign_function((void*)&gzetak,"gzetak",1024);
  register_foreign_function((void*)&glambdak,"glambdak",1024);
  register_foreign_function((void*)&tayl,"tayl",1024);
  register_foreign_function((void*)&legendre,"legendre",1024);
  register_foreign_function((void*)&tchebi,"tchebi",1024);
  register_foreign_function((void*)&mathilbert,"mathilbert",1024);
  register_foreign_function((void*)&matqpascal,"matqpascal",1024);
  register_foreign_function((void*)&laplace,"laplace",1024);
  register_foreign_function((void*)&gprec,"gprec",1024);
  register_foreign_function((void*)&convol,"convol",1024);
  register_foreign_function((void*)&ggrando,"ggrando",1024);
  register_foreign_function((void*)&lll,"lll",1024);
  register_foreign_function((void*)&lllgram,"lllgram",1024);
  register_foreign_function((void*)&lllgramint,"lllgramint",1024);
  register_foreign_function((void*)&lllint,"lllint",1024);
  register_foreign_function((void*)&lllintpartial,"lllintpartial",1024);
  register_foreign_function((void*)&lllgramkerim,"lllgramkerim",1024);
  register_foreign_function((void*)&lllkerim,"lllkerim",1024);
  register_foreign_function((void*)&binomial,"binomial",1024);
  register_foreign_function((void*)&cyclo,"cyclo",1024);
  register_foreign_function((void*)&vecsort,"vecsort",1024);
  register_foreign_function((void*)&lindep,"lindep",1024);
  register_foreign_function((void*)&algdep,"algdep",1024);
  register_foreign_function((void*)&changevar,"changevar",1024);
  register_foreign_function((void*)&ordred,"ordred",1024);
  register_foreign_function((void*)&polrecip,"polrecip",1024);
  register_foreign_function((void*)&reorder,"reorder",1024);
  register_foreign_function((void*)&sort,"sort",1024);
  register_foreign_function((void*)&lexsort,"lexsort",1024);
  register_foreign_function((void*)&indexsort,"indexsort",1024);
  register_foreign_function((void*)&polsym,"polsym",1024);
  register_foreign_function((void*)&minim,"minim",1024);
  register_foreign_function((void*)&polred,"polred",1024);
  register_foreign_function((void*)&factoredpolred,"factoredpolred",1024);
  register_foreign_function((void*)&smallpolred,"smallpolred",1024);
  register_foreign_function((void*)&polred2,"polred2",1024);
  register_foreign_function((void*)&factoredpolred2,"factoredpolred2",1024);
  register_foreign_function((void*)&polredabs,"polredabs",1024);
  register_foreign_function((void*)&smallpolred2,"smallpolred2",1024);
  register_foreign_function((void*)&polymodrecip,"polymodrecip",1024);
  register_foreign_function((void*)&genrand,"genrand",1024);
  register_foreign_function((void*)&numtoperm,"numtoperm",1024);
  register_foreign_function((void*)&permtonum,"permtonum",1024);
  register_foreign_function((void*)&setrand,"setrand",1024);
  register_foreign_function((void*)&getrand,"getrand",1024);
  register_foreign_function((void*)&getstack,"getstack",1024);
  register_foreign_function((void*)&gettime,"gettime",1024);
  register_foreign_function((void*)&getheap,"getheap",1024);
  register_foreign_function((void*)&polint,"polint",1024);
  register_foreign_function((void*)&gtoset,"gtoset",1024);
  register_foreign_function((void*)&setunion,"setunion",1024);
  register_foreign_function((void*)&setintersect,"setintersect",1024);
  register_foreign_function((void*)&setminus,"setminus",1024);
  register_foreign_function((void*)&dirmul,"dirmul",1024);
  register_foreign_function((void*)&dirdiv,"dirdiv",1024);
  register_foreign_function((void*)&dirzetak,"dirzetak",1024);
  register_foreign_function((void*)&setsearch,"setsearch",1024);
  register_foreign_function((void*)&buchimag,"buchimag",1024);
  register_foreign_function((void*)&buchreal,"buchreal",1024);
  register_foreign_function((void*)&buchall,"buchall",1024);
  register_foreign_function((void*)&isprincipal,"isprincipal",1024);
  register_foreign_function((void*)&isprincipalgen,"isprincipalgen",1024);
  register_foreign_function((void*)&isunit,"isunit",1024);
  register_foreign_function((void*)&signunits,"signunits",1024);
  register_foreign_function((void*)&buchfu,"buchfu",1024);
  register_foreign_function((void*)&buchnarrow,"buchnarrow",1024);
  register_foreign_function((void*)&ghell,"ghell",1024);
  register_foreign_function((void*)&initell,"initell",1024);
  register_foreign_function((void*)&smallinitell,"smallinitell",1024);
  register_foreign_function((void*)&zell,"zell",1024);
  register_foreign_function((void*)&coordch,"coordch",1024);
  register_foreign_function((void*)&pointch,"pointch",1024);
  register_foreign_function((void*)&addell,"addell",1024);
  register_foreign_function((void*)&subell,"subell",1024);
  register_foreign_function((void*)&powell,"powell",1024);
  register_foreign_function((void*)&mathell,"mathell",1024);
  register_foreign_function((void*)&bilhell,"bilhell",1024);
  register_foreign_function((void*)&ordell,"ordell",1024);
  register_foreign_function((void*)&apell,"apell",1024);
  register_foreign_function((void*)&anell,"anell",1024);
  register_foreign_function((void*)&akell,"akell",1024);
  register_foreign_function((void*)&elllocalred,"elllocalred",1024);
  register_foreign_function((void*)&ellglobalred,"ellglobalred",1024);
  register_foreign_function((void*)&elllseries,"elllseries",1024);
  register_foreign_function((void*)&pointell,"pointell",1024);
  register_foreign_function((void*)&elltaniyama,"elltaniyama",1024);
  register_foreign_function((void*)&orderell,"orderell",1024);
  register_foreign_function((void*)&torsell,"torsell",1024);
  register_foreign_function((void*)&oncurve,"oncurve",1024);
  register_foreign_function((void*)&GENtostr,"GENtostr",1026);
  register_foreign_function((void*)&gadd,"gadd",1024);
  register_foreign_function((void*)&gsub,"gsub",1024);
  register_foreign_function((void*)&gmul,"gmul",1024);
  register_foreign_function((void*)&gdiv,"gdiv",1024);
  register_foreign_function((void*)&compo,"compo",1024);
  register_foreign_function((void*)&gsqr,"gsqr",1024);
  register_foreign_function((void*)&gneg,"gneg",1024);
  register_foreign_function((void*)&gabs,"gabs",1024);
  register_foreign_function((void*)&gpow,"gpow",1024);
  register_foreign_function((void*)&gpowgs,"gpowgs",1024);
  register_foreign_function((void*)&gmax,"gmax",1024);
  register_foreign_function((void*)&gmin,"gmin",1024);
  register_foreign_function((void*)&ginv,"ginv",1024);
  register_foreign_function((void*)&denom,"denom",1024);
  register_foreign_function((void*)&numer,"numer",1024);
  register_foreign_function((void*)&lift,"lift",1024);
  register_foreign_function((void*)&centerlift,"centerlift",1024);
  register_foreign_function((void*)&vecmax,"vecmax",1024);
  register_foreign_function((void*)&vecmin,"vecmin",1024);
  register_foreign_function((void*)&gmodulo,"gmodulo",1024);
  register_foreign_function((void*)&simplify,"simplify",1024);
  register_foreign_function((void*)&gmod,"gmod",1024);
  register_foreign_function((void*)&gshift,"gshift",1024);
  register_foreign_function((void*)&gmul2n,"gmul2n",1024);
  register_foreign_function((void*)&gsubst,"gsubst",1024);
  register_foreign_function((void*)&deriv,"deriv",1024);
  register_foreign_function((void*)&integ,"integ",1024);
  register_foreign_function((void*)&recip,"recip",1024);
  register_foreign_function((void*)&ground,"ground",1024);
  register_foreign_function((void*)&gceil,"gceil",1024);
  register_foreign_function((void*)&gfloor,"gfloor",1024);
  register_foreign_function((void*)&gfrac,"gfrac",1024);
  register_foreign_function((void*)&gtrunc,"gtrunc",1024);
  register_foreign_function((void*)&gdivent,"gdivent",1024);
  register_foreign_function((void*)&gdiventres,"gdiventres",1024);
  register_foreign_function((void*)&glt,"glt",1024);
  register_foreign_function((void*)&gle,"gle",1024);
  register_foreign_function((void*)&ggt,"ggt",1024);
  register_foreign_function((void*)&gge,"gge",1024);
  register_foreign_function((void*)&geq,"geq",1024);
  register_foreign_function((void*)&gne,"gne",1024);
  register_foreign_function((void*)&gand,"gand",1024);
  register_foreign_function((void*)&gor,"gor",1024);
  register_foreign_function((void*)&glength,"glength",1024);
  register_foreign_function((void*)&matsize,"matsize",1024);
  register_foreign_function((void*)&truecoeff,"truecoeff",1024);
  register_foreign_function((void*)&gtopoly,"gtopoly",1024);
  register_foreign_function((void*)&gtopolyrev,"gtopolyrev",1024);
  register_foreign_function((void*)&gtoser,"gtoser",1024);
  register_foreign_function((void*)&gtovec,"gtovec",1024);
  register_foreign_function((void*)&gdivround,"gdivround",1024);
  register_foreign_function((void*)&gcmp0,"gcmp0",1024);
  register_foreign_function((void*)&gcmp1,"gcmp1",1024);
  register_foreign_function((void*)&gcmp_1,"gcmp_1",1024);
  register_foreign_function((void*)&gcmp,"gcmp",1024);
  register_foreign_function((void*)&lexcmp,"lexcmp",1024);
  register_foreign_function((void*)&gequal,"gequal",1024);
  register_foreign_function((void*)&gsigne,"gsigne",1024);
  register_foreign_function((void*)&gvar,"gvar",1024);
  register_foreign_function((void*)&precision,"precision",1024);
  register_foreign_function((void*)&isexactzero,"isexactzero",1024);
  register_foreign_function((void*)&padicprec,"padicprec",1024);
  register_foreign_function((void*)&taille2,"taille2",1024);
  register_foreign_function((void*)&ggval,"ggval",1024);
  register_foreign_function((void*)&roots,"roots",1024);
  register_foreign_function((void*)&ggcd,"ggcd",1024);
  register_foreign_function((void*)&vecbezout,"vecbezout",1024);
  register_foreign_function((void*)&glcm,"glcm",1024);
  register_foreign_function((void*)&vecbezoutres,"vecbezoutres",1024);
  register_foreign_function((void*)&content,"content",1024);
  register_foreign_function((void*)&primpart,"primpart",1024);
  register_foreign_function((void*)&primitive_part,"primitive_part",1024);
  register_foreign_function((void*)&factorff,"factorff",1024);
  register_foreign_function((void*)&factmod,"factmod",1024);
  register_foreign_function((void*)&rootmod,"rootmod",1024);
  register_foreign_function((void*)&rootmod2,"rootmod2",1024);
  register_foreign_function((void*)&factor,"factor",1024);
  register_foreign_function((void*)&gisirreducible,"gisirreducible",1024);
  register_foreign_function((void*)&factpol,"factpol",1024);
  register_foreign_function((void*)&simplefactmod,"simplefactmod",1024);
  register_foreign_function((void*)&factcantor,"factcantor",1024);
  register_foreign_function((void*)&subres0,"subres0",1024);
  register_foreign_function((void*)&discsr,"discsr",1024);
  register_foreign_function((void*)&quadpoly,"quadpoly",1024);
  register_foreign_function((void*)&quadgen,"quadgen",1024);
  register_foreign_function((void*)&quaddisc,"quaddisc",1024);
  register_foreign_function((void*)&resultant2,"resultant2",1024);
  register_foreign_function((void*)&sylvestermatrix,"sylvestermatrix",1024);
  register_foreign_function((void*)&polfnf,"polfnf",1024);
  register_foreign_function((void*)&newtonpoly,"newtonpoly",1024);
  register_foreign_function((void*)&padicappr,"padicappr",1024);
  register_foreign_function((void*)&rootpadic,"rootpadic",1024);
  register_foreign_function((void*)&factorpadic4,"factorpadic4",1024);
  register_foreign_function((void*)&sturmpart,"sturmpart",1024);
  register_foreign_function((void*)&greal,"greal",1024);
  register_foreign_function((void*)&gimag,"gimag",1024);
  register_foreign_function((void*)&teich,"teich",1024);
  register_foreign_function((void*)&agm,"agm",1024);
  register_foreign_function((void*)&gsqrt,"gsqrt",1024);
  register_foreign_function((void*)&gexp,"gexp",1024);
  register_foreign_function((void*)&glog,"glog",1024);
  register_foreign_function((void*)&gcos,"gcos",1024);
  register_foreign_function((void*)&gsin,"gsin",1024);
  register_foreign_function((void*)&gtan,"gtan",1024);
  register_foreign_function((void*)&gatan,"gatan",1024);
  register_foreign_function((void*)&gasin,"gasin",1024);
  register_foreign_function((void*)&gacos,"gacos",1024);
  register_foreign_function((void*)&gch,"gch",1024);
  register_foreign_function((void*)&gsh,"gsh",1024);
  register_foreign_function((void*)&gth,"gth",1024);
  register_foreign_function((void*)&gath,"gath",1024);
  register_foreign_function((void*)&gash,"gash",1024);
  register_foreign_function((void*)&garg,"garg",1024);
  register_foreign_function((void*)&gpsi,"gpsi",1024);
  register_foreign_function((void*)&kbessel,"kbessel",1024);
  register_foreign_function((void*)&hyperu,"hyperu",1024);
  register_foreign_function((void*)&jbesselh,"jbesselh",1024);
  register_foreign_function((void*)&gzeta,"gzeta",1024);
  register_foreign_function((void*)&eint1,"eint1",1024);
  register_foreign_function((void*)&gerfc,"gerfc",1024);
  register_foreign_function((void*)&eta,"eta",1024);
  register_foreign_function((void*)&jell,"jell",1024);
  register_foreign_function((void*)&weberf2,"weberf2",1024);
  register_foreign_function((void*)&weberf,"weberf",1024);
  register_foreign_function((void*)&incgam,"incgam",1024);
  register_foreign_function((void*)&bernreal,"bernreal",1024);
  register_foreign_function((void*)&bernvec,"bernvec",1024);
  register_foreign_function((void*)&gach,"gach",1024);
  register_foreign_function((void*)&ggamma,"ggamma",1024);
  register_foreign_function((void*)&ggamd,"ggamd",1024);
  register_foreign_function((void*)&mppi,"mppi",1024);
  register_foreign_function((void*)&mpeuler,"mpeuler",1024);
  register_foreign_function((void*)&gpolylog,"gpolylog",1024);
  register_foreign_function((void*)&dilog,"dilog",1024);
  register_foreign_function((void*)&polylogd,"polylogd",1024);
  register_foreign_function((void*)&polylogdold,"polylogdold",1024);
  register_foreign_function((void*)&polylogp,"polylogp",1024);
  register_foreign_function((void*)&glngamma,"glngamma",1024);
  register_foreign_function((void*)&get_integer_data,"get_integer_data",1024);
  register_foreign_function((void*)&set_integer_data,"set_integer_data",1024);
  register_foreign_function((void*)&cgetg,"cgetg",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_C_STRING,"MODULE__PARI__CONSTANT_MAP_C_STRING",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_LONG,"MODULE__PARI__CONSTANT_MAP_LONG",1024);
  register_foreign_function((void*)&MODULE__PARI__CONSTANT_MAP_ULONG,"MODULE__PARI__CONSTANT_MAP_ULONG",1024);
}

void module__pari__fini_function (module_t* module)
{
pari_close();

}
